unit UfrmPrinc;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TfrmPrinc = class(TForm)
    StatusBar1: TStatusBar;
    img11: TImage;
    img21: TImage;
    img31: TImage;
    img41: TImage;
    img51: TImage;
    img61: TImage;
    img71: TImage;
    img12: TImage;
    img22: TImage;
    img32: TImage;
    img42: TImage;
    img52: TImage;
    img62: TImage;
    img72: TImage;
    img13: TImage;
    img23: TImage;
    img33: TImage;
    img43: TImage;
    img53: TImage;
    img63: TImage;
    img73: TImage;
    img14: TImage;
    img24: TImage;
    img34: TImage;
    img44: TImage;
    img54: TImage;
    img64: TImage;
    img74: TImage;
    img15: TImage;
    img25: TImage;
    img35: TImage;
    img45: TImage;
    img55: TImage;
    img65: TImage;
    img75: TImage;
    img16: TImage;
    img26: TImage;
    img36: TImage;
    img46: TImage;
    img56: TImage;
    img66: TImage;
    img76: TImage;
    imagePlateau: TImage;
    main1: TImage;
    main2: TImage;
    main3: TImage;
    main4: TImage;
    main5: TImage;
    main6: TImage;
    main7: TImage;
    TimerHeure: TTimer;
    TimerTemps: TTimer;
    imageMainJaune: TImage;
    ImageRouge: TImage;
    ImageJaune: TImage;
    Label4: TLabel;
    imageMainRouge: TImage;
    procedure FormActivate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TimerHeureTimer(Sender: TObject);
    procedure Col1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure PlacePointOnClic(Sender: TObject);
    procedure mmQuitterClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure StatusBar1DrawPanel(StatusBar1: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);

  private
    { Dclarations prives }
    iJoueur, iMainActif : integer;
    sEtatColonne, sJoueur1, sJoueur2 : string;
    aoPlateau : Array [1..7,1..6]OF Integer;
    bVictory : boolean;
    CurAncien : TCursor;
    function EtatMainActif(iInteger: integer; Etat : boolean) : boolean;
    function PlacePion : boolean;
    function TestVictoire(iJoueurTester : integer) : boolean;
    function AnimationVictoire(i1, i2, i3, i4, iGagnant : integer) : boolean;
    function InitPartie : boolean;
    function LanceNouvellePartie : boolean;
    function IdentificationJoueur : boolean;
  public
    { Dclarations publiques }
    sVainqueur : string;
  end;

var
  frmPrinc: TfrmPrinc;

implementation

uses StrUtils, UfrmVictoire;

{$R *.dfm}

procedure TfrmPrinc.FormActivate(Sender: TObject);
begin
  IdentificationJoueur;
  InitPartie;
end;

procedure TfrmPrinc.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_RIGHT : begin
                EtatMainActif(iMainActif,false);
                Inc(iMainActif);
                if iMainActif = 8 then
                  iMainActif := 1;
                EtatMainActif(iMainActif,true);
               end;
    VK_LEFT : begin
                EtatMainActif(iMainActif,false);
                Dec(iMainActif);
                if iMainActif = 0 then
                  iMainActif := 7;
                EtatMainActif(iMainActif,true);
              end;
    VK_DOWN : begin
                PlacePion;
                EtatMainActif(iMainActif,true);
              end;
    VK_F2 :   begin
                if MessageDlg('Desirez-vous Quitter la Partie en Cours ?',mtConfirmation,[mbYes,mbNo],0) = mrYes then
                  Application.Terminate;
              end;
    VK_F1 :   begin
                LanceNouvellePartie;
              end;
    VK_F6 :   begin
                IdentificationJoueur;
              end;
    end;
end;

function TfrmPrinc.EtatMainActif(iInteger: integer; Etat : boolean): boolean;
var
  imgImage : TImage;
begin
//  StatusBar1.Panels[0].Text := 'iMainActif : '+IntToStr(iInteger);
  iMainActif := iInteger;
  imgImage := TImage(frmPrinc.FindComponent('main'+IntToStr(iInteger)));
  if imgImage <> Nil then
  begin
    if Etat then
    begin
      if iJoueur = 1 then imgImage.Picture := imageMainRouge.Picture
      else imgImage.Picture := imageMainJaune.Picture
    end
    else
    begin
      imgImage.Picture := nil;
    end;
    Result := true;
  end
  else
    result := false;
end;

function TfrmPrinc.PlacePion : boolean;
var
  imgImage : TImage;
  iTemp : integer;
begin
  if Screen.Cursor <> crHourGlass then
  begin
    if StrtoInt(sEtatColonne[iMainActif]) = 7 then
      ShowMessage('Joueur '+IntToStr(iJoueur)+' Rejouez !!!')
    else
    begin
      imgImage := TImage(frmPrinc.FindComponent('img'+IntToStr(iMainActif)+sEtatColonne[iMainActif]));
      if imgImage <> Nil then
      begin
        aoPlateau[iMainActif,StrToInt(sEtatColonne[iMainActif])] := iJoueur;
        case iJoueur of
          1 : imgImage.Picture := ImageRouge.Picture;
          2 : imgImage.Picture := ImageJaune.Picture;
        end;

        iTemp := StrToInt(sEtatColonne);
        Case iMainActif of
          1 : iTemp := iTemp + 1000000;
          2 : iTemp := iTemp + 100000;
          3 : iTemp := iTemp + 10000;
          4 : iTemp := iTemp + 1000;
          5 : iTemp := iTemp + 100;
          6 : iTemp := iTemp + 10;
          7 : iTemp := iTemp + 1;
        end;

        TestVictoire(iJoueur);

        if bVictory then
        begin
          case iJoueur of
            1 : sVainqueur := sJoueur1;
            2 : sVainqueur := sJoueur2;
          end;
          frmVictoire.ShowModal;
          if MessageDlg('Recommencer une Nouvelle Partie ?',mtConfirmation,[MbYes,MbNo],0) = mrYes then
            InitPartie
          else
            if MessageDlg('Quitter Puissance 4 ?',mtConfirmation,[mbYes,mbNo],0) = mrYes then
              Application.Terminate
            else
              InitPartie
        end
        else if iTemp = 7777777 then
        begin
          ShowMessage('Partie Termin - Match Nul entre '+sJoueur1+' et '+sJoueur2);
          InitPartie;
        end
        else
        begin
          case iJoueur of
            1 : iJoueur := 2;
            2 : iJoueur := 1;
          end;


          sEtatColonne := IntToStr(iTemp);
//          StatusBar1.Panels[0].Text := 'iMainActif : '+IntToStr(iMainActif);
          Result := true;
          case iJoueur of
              1 : begin
                    StatusBar1.Panels[1].Text := sJoueur1+' - Pion Rouges';
                    Label4.Font.Color := clRed;
                  end;
              2 : begin
                    StatusBar1.Panels[1].Text := sJoueur2+' - Pion Jaunes';
                    Label4.Font.Color := clYellow;
                  end;
            end;
        end;
      end
      else
        result := false;
    end;
  end;
end;

procedure TfrmPrinc.TimerHeureTimer(Sender: TObject);
begin
  StatusBar1.Panels[3].Text := DateTimeToStr(now);
end;

function TfrmPrinc.TestVictoire(iJoueurTester: integer): boolean;
var
  iX, iY, iNbPionOk, iPion1, iPion2, iPion3, iPion4 : integer;
begin
  bVictory := false;
  iNbPionOk := 0;
  iPion1 := 0;
  iPion2 := 0;
  iPion3 := 0;
  iPion4 := 0;

  if not bVictory then
  begin
    // Victoire Horizontal
    for iY := 1 to 6 do
    begin
      iNbPionOk := 0;
      for iX := 1 to 7 do
      begin
        if aoPlateau[iX,iY] = iJoueurTester then
        begin
          Inc(iNbPionOk);
          case iNbPionOk of
            1 : iPion1 := StrToInt(IntToStr(iX)+IntToStr(iY));
            2 : iPion2 := StrToInt(IntToStr(iX)+IntToStr(iY));
            3 : iPion3 := StrToInt(IntToStr(iX)+IntToStr(iY));
            4 : begin
                  iPion4 := StrToInt(IntToStr(iX)+IntToStr(iY));
                  AnimationVictoire(iPion1,iPion2,iPion3,iPion4,iJoueurTester);
                  bVictory := true;
                  Exit;
                end;
          end;
        end
        else
        begin
          iNbPionOk := 0;
        end;
      end;
    end;
  end;

  if not bVictory then
  begin
    // Victoire Vertical
    for iX := 1 to 7 do
    begin
      iNbPionOk := 0;
      for iY := 1 to 6 do
      begin
        if aoPlateau[iX,iY] = iJoueurTester then
        begin
          Inc(iNbPionOk);
          case iNbPionOk of
            1 : iPion1 := StrToInt(IntToStr(iX)+IntToStr(iY));
            2 : iPion2 := StrToInt(IntToStr(iX)+IntToStr(iY));
            3 : iPion3 := StrToInt(IntToStr(iX)+IntToStr(iY));
            4 : begin
                  iPion4 := StrToInt(IntToStr(iX)+IntToStr(iY));
                  AnimationVictoire(iPion1,iPion2,iPion3,iPion4,iJoueurTester);
                  bVictory := true;
                  Exit;
                end;
          end;
        end
        else
        begin
          iNbPionOk := 0;
        end;
      end;
    end;
  end;

  // Victoire Diagonal  /
  if not bVictory then
  begin
    for iX := 1 to 4 do
    begin
      for iY := 1 to 3 do
      begin
        if aoPlateau[iX,iY] = iJoueurTester then
        begin
          iPion1 := StrToInt(IntToStr(iX)+IntToStr(iY));
          if aoPlateau[iX+1,iY+1] = iJoueurTester then
          begin
            iPion2 := StrToInt(IntToStr(iX+1)+IntToStr(iY+1));
            if aoPlateau[iX+2,iY+2] = iJoueurTester then
            begin
              iPion3 := StrToInt(IntToStr(iX+2)+IntToStr(iY+2));
              if aoPlateau[iX+3,iY+3] = iJoueurTester then
              begin
                iPion4 := StrToInt(IntToStr(iX+3)+IntToStr(iY+3));
                AnimationVictoire(iPion1,iPion2,iPion3,iPion4,iJoueurTester);
                bVictory := true;
                Exit;
              end;
            end;
          end;
        end;
      end;
    end;
  end;

  // Victoire Diagonal  \
  if not bVictory then
  begin
    for iX := 7 downto 4 do
    begin
      for iY := 1 to 3 do
      begin
        if aoPlateau[iX,iY] = iJoueurTester then
        begin
          iPion1 := StrToInt(IntToStr(iX)+IntToStr(iY));
          if aoPlateau[iX-1,iY+1] = iJoueurTester then
          begin
            iPion2 := StrToInt(IntToStr(iX-1)+IntToStr(iY+1));
            if aoPlateau[iX-2,iY+2] = iJoueurTester then
            begin
              iPion3 := StrToInt(IntToStr(iX-2)+IntToStr(iY+2));
              if (aoPlateau[iX-3,iY+3] = iJoueurTester) then
              begin
                iPion4 := StrToInt(IntToStr(iX-3)+IntToStr(iY+3));
                AnimationVictoire(iPion1,iPion2,iPion3,iPion4,iJoueurTester);
                bVictory := true;
                Exit;
              end;
            end;
          end;
        end
      end;
    end;
  end;
  Result := bVictory;
end;

function TfrmPrinc.AnimationVictoire(i1, i2, i3, i4, iGagnant : integer): boolean;
var
  imgImage : TImage;
  iIndice : integer;
begin
  CurAncien := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  for iIndice := 0 to 1 do
  begin
    // Animation Pion 1
    imgImage := TImage(frmPrinc.FindComponent('img'+IntToStr(i1)));
    if imgImage <> Nil then
    begin
      imgImage.Picture := nil;
      Sleep(150);
      Application.ProcessMessages;
      case iGagnant of
          1 : imgImage.Picture := ImageRouge.Picture;
          2 : imgImage.Picture := ImageJaune.Picture;
      end;
    end;
    // Animation Pion 2
    imgImage := TImage(frmPrinc.FindComponent('img'+IntToStr(i2)));
    if imgImage <> Nil then
    begin
      imgImage.Picture := nil;
      Sleep(150);
      Application.ProcessMessages;
      case iGagnant of
          1 : imgImage.Picture := ImageRouge.Picture;
          2 : imgImage.Picture := ImageJaune.Picture;
      end;
    end;
    // Animation Pion 3
    imgImage := TImage(frmPrinc.FindComponent('img'+IntToStr(i3)));
    if imgImage <> Nil then
    begin
      imgImage.Picture := nil;
      Sleep(150);
      Application.ProcessMessages;
      case iGagnant of
          1 : imgImage.Picture := ImageRouge.Picture;
          2 : imgImage.Picture := ImageJaune.Picture;
      end;
    end;
    // Animation Pion 4
    imgImage := TImage(frmPrinc.FindComponent('img'+IntToStr(i4)));
    if imgImage <> Nil then
    begin
      imgImage.Picture := nil;
      Sleep(150);
      Application.ProcessMessages;
      case iGagnant of
          1 : imgImage.Picture := ImageRouge.Picture;
          2 : imgImage.Picture := ImageJaune.Picture;
      end;
    end;
  end;

  Screen.Cursor := CurAncien;

end;

function TfrmPrinc.InitPartie: boolean;
Var
  i, x, y : Integer;
begin
  for x := 1 to 7 do
    for y := 1 to 6 do
      aoPlateau[x,y] := 0;

  for i:=0 To ComponentCount-1 Do
    If Components[i] Is TImage Then
    begin
      If AnsiContainsStr(TImage(Components[i]).Name,'img') then
        TImage(Components[i]).Picture := nil;
      If (AnsiContainsStr(TImage(Components[i]).Name,'main')) and (TImage(Components[i]).Name <> 'main1') then
        TImage(Components[i]).Picture := nil;
    end;
  iMainActif := 1;
  EtatMainActif(1,true);
  sEtatColonne := '1111111';
  iJoueur := 1;
  EtatMainActif(iMainActif,true);

  /// Init des Panels de la StatusBar
  StatusBar1.Panels[0].Text := 'LE PUISSANCE 4 - V1.0';

  //  StatusBar1.Panels[0].Text := 'iMainActif : '+IntToStr(iMainActif);
  case iJoueur of
    1 : begin
          StatusBar1.Panels[1].Text := sJoueur1+' - Pion Rouges';
          Label4.Font.Color := clRed;
        end;
    2 : begin
          StatusBar1.Panels[1].Text := sJoueur2+' - Pion Jaunes';
          Label4.Font.Color := clYellow;
        end;
  end;
  StatusBar1.Panels[3].Text := DateTimeToStr(now);
end;

procedure TfrmPrinc.Col1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if iMainActif <> TImage(Sender).Tag then
  begin
    EtatMainActif(iMainActif,false);
    EtatMainActif(TImage(Sender).Tag,True)
  end;
end;

procedure TfrmPrinc.PlacePointOnClic(Sender: TObject);
begin
  PlacePion;
  EtatMainActif(iMainActif,true);
end;

procedure TfrmPrinc.mmQuitterClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TfrmPrinc.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Application.Terminate;
end;

function TfrmPrinc.LanceNouvellePartie: boolean;
begin
  if sEtatColonne <> '1111111' then
    if MessageDlg('Desirez-vous Quitter la Partie en Cours et en Recommencez une ?',mtConfirmation,[mbYes,mbNo],0) = mrYes then
      InitPartie;
end;

function TfrmPrinc.IdentificationJoueur: boolean;
begin
  sJoueur1 := InputBox('Option','Nom du Joueur N1 ?','Joueur 1');
  if sJoueur1 = '' then sJoueur1 := 'Joueur 1';
  sJoueur2 := InputBox('Option','Nom du Joueur N2 ?','Joueur 2');
  if sJoueur2 = '' then sJoueur2 := 'Joueur 2';
end;

procedure TfrmPrinc.StatusBar1DrawPanel(StatusBar1: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
begin
  if iJoueur = 1 then begin
    StatusBar1.Canvas.Font.Color := clRed;
    StatusBar1.Canvas.Textout(Rect.Left, Rect.top, StatusBar1.Panels[1].Text)
   end else begin
    StatusBar1.Canvas.Font.Color := clYellow;
    StatusBar1.Canvas.Textout(Rect.Left, Rect.top, StatusBar1.Panels[1].Text);
    end;
end;

end.

